/*
 * CaseScanner.java
 *
 * Created on 8 ottobre 2005, 20.18
 */


import java.io.*;

/**
 *
 * @author Claudio Guidi
 */
public class CaseScanner {
    int LastTokenPosition;       //Ultima posizione utile per un token
    int InitialTokenPosition;    //Posizione iniziale token
    int ScannerPosition;         //Posizione attuale dello scanner
    String InputString;          //Variabile che contiene l'input
    int State;                   //Memorizza lo stato corrente dell'automa
    
    
    /** Creates a new instance of CaseScanner */
    
    public CaseScanner(String s) {
        InputString=s;
        LastTokenPosition=0;
        InitialTokenPosition=0;
    }
    
    public String newToken(){
        char c;
        int ret;
        int TempPos;
        
        ret=1;
        State=1;
        ScannerPosition=InitialTokenPosition;
        if (ScannerPosition >= InputString.length()) return("END");
        while ((ScannerPosition < InputString.length()) && (ret==1)){
            c=InputString.charAt(ScannerPosition);  //leggo il prossimo carattere
            switch (State){
                case 1: //Siamo nello stato iniziale
                    
                    State=13;              //Setto da subito lo stato di errore che 
                                           //eventualmente verr cambiato sotto
                    if (c=='i') {
                        State=2;
                        LastTokenPosition=ScannerPosition;
                    }
                    if (((c>='a') && (c<='h'))|| ((c>='j') && (c<='z'))) {
                        LastTokenPosition=ScannerPosition;
                        State=4;
                    }
                    if (c=='.') State=5;
                    if ((c>='0') && (c<='9')) {
                        State=7;
                        LastTokenPosition=ScannerPosition;
                    }
                    if (c=='-') {
                        State=9;
                        LastTokenPosition=ScannerPosition;
                    }
                    if ((c==' ') || (c=='\n') || (c=='\t')) {
                        InitialTokenPosition=ScannerPosition+1;
                        State=1;
                    }
                    break;
                
                case 2:
                    if (c=='f') {
                        State=3;
                        LastTokenPosition=ScannerPosition;
                    } 
                    else {
                         if (((c>='a') && (c<='e')) || ((c>='g') && (c<='z'))
                             || ((c>='0') && (c<='9'))) {
                             LastTokenPosition=ScannerPosition;
                             State=4;
                         }
                         else ret=2;
                    }     
                    break;
                
                case 3: 
                    if (((c>='a') && (c<='z'))
                         || ((c>='0') && (c<='9'))) {
                        LastTokenPosition=ScannerPosition;
                        State=4;
                    }
                    else ret=3;
                    break;
                    
                case 4:
                    if (((c>='a') && (c<='z'))
                         || ((c>='0') && (c<='9'))) {
                        LastTokenPosition=ScannerPosition;
                        State=4;
                    }
                    else ret=4;
                    break;
                    
                case 5:
                    if ((c>='0') && (c<='9')) {
                        State=6;
                        LastTokenPosition=ScannerPosition;
                    }
                    else ret=5;
                    break;
                case 6:
                    if ((c>='0') && (c<='9')) {
                        State=6;
                        LastTokenPosition=ScannerPosition;
                    }
                    else ret=6;
                    break;
                
                case 7:
                    if ((c>='0') && (c<='9')) {
                        State=7;
                        LastTokenPosition=ScannerPosition;
                    }
                    else {
                        if (c=='.') {
                            State=6;
                            LastTokenPosition=ScannerPosition;
                        }
                        else ret=7;
                    }    
                    break;
                
                case 9:
                    if (c=='-') State=10;
                    else ret=9;
                    break;
                
                case 10:
                    if (((c>='a') && (c<='z'))
                         || ((c>='A') && (c<='Z')) || (c==' ')) State=10;
                    else 
                        if (c==':') {
                            InitialTokenPosition=ScannerPosition+1;
                            State=1;
                        }
                        else ret=10;
                    break;
                    
                case 13: ret=13; 
                    break;
                
            }
            ScannerPosition+=1;
        }
        if (InputString.length()>= (ScannerPosition-1)) ret=State;
        switch (ret){
            case 1: break;
            case 2:
                InitialTokenPosition=LastTokenPosition+1;
                return("ID(i)");
            case 3: 
                InitialTokenPosition=LastTokenPosition+1;
                return("IF");
            case 4: 
                TempPos=InitialTokenPosition;
                InitialTokenPosition=LastTokenPosition+1;
                return("ID("+InputString.substring(TempPos,LastTokenPosition+1)+")");
            case 5:
                InitialTokenPosition=LastTokenPosition+1;
                return("ERROR");
            case 6:
                TempPos=InitialTokenPosition;
                InitialTokenPosition=LastTokenPosition+1;
                return("REAL("+InputString.substring(TempPos,LastTokenPosition+1)+")");
            case 7:
                TempPos=InitialTokenPosition;
                InitialTokenPosition=LastTokenPosition+1;
                return("NUM("+InputString.substring(TempPos,LastTokenPosition+1)+")");
            case 9:
            case 10:
                TempPos=InitialTokenPosition;
                InitialTokenPosition=LastTokenPosition+1;
                return("ERROR("+InputString.substring(TempPos,LastTokenPosition+1)+")");
            case 13:
                InitialTokenPosition+=1;
                return("ERROR");
            default:
                return("END");
        }
        return("END");
    }
    
}